/* PolkitDialog.c generated by valac 0.42.3, the Vala compiler
 * generated from PolkitDialog.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC.
 * Copyright (C) 2015-2016 Ikey Doherty <ikey@solus-project.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/*
 * Code based on budgie-desktop:
 * https://github.com/solus-project/budgie-desktop
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <polkitagent/polkitagent.h>
#include <polkit/polkit.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pwd.h>
#include <sys/types.h>
#include <grp.h>


#define AG_WIDGETS_TYPE_POLKIT_DIALOG (ag_widgets_polkit_dialog_get_type ())
#define AG_WIDGETS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog))
#define AG_WIDGETS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))
#define AG_WIDGETS_IS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_IS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_POLKIT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))

typedef struct _AgWidgetsPolkitDialog AgWidgetsPolkitDialog;
typedef struct _AgWidgetsPolkitDialogClass AgWidgetsPolkitDialogClass;
typedef struct _AgWidgetsPolkitDialogPrivate AgWidgetsPolkitDialogPrivate;
enum  {
	AG_WIDGETS_POLKIT_DIALOG_0_PROPERTY,
	AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* ag_widgets_polkit_dialog_properties[AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL,
	AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS
};
static guint ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS] = {0};

struct _AgWidgetsPolkitDialog {
	GtkDialog parent_instance;
	AgWidgetsPolkitDialogPrivate * priv;
	gboolean was_canceled;
};

struct _AgWidgetsPolkitDialogClass {
	GtkDialogClass parent_class;
};

struct _AgWidgetsPolkitDialogPrivate {
	PolkitAgentSession* pk_session;
	PolkitIdentity* pk_identity;
	GCancellable* cancellable;
	gulong error_signal_id;
	gulong request_signal_id;
	gulong info_signal_id;
	gulong complete_signal_id;
	GList* idents;
	gchar* cookie;
	gboolean canceling;
	GtkRevealer* feedback_revealer;
	GtkLabel* password_label;
	GtkLabel* password_feedback;
	GtkEntry* password_entry;
	GtkComboBox* idents_combo;
};


static gint AgWidgetsPolkitDialog_private_offset;
static gpointer ag_widgets_polkit_dialog_parent_class = NULL;

GType ag_widgets_polkit_dialog_get_type (void) G_GNUC_CONST;
AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_new (const gchar* message,
                                                     const gchar* icon_name,
                                                     const gchar* _cookie,
                                                     GList* _idents,
                                                     GCancellable* _cancellable);
AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_construct (GType object_type,
                                                           const gchar* message,
                                                           const gchar* icon_name,
                                                           const gchar* _cookie,
                                                           GList* _idents,
                                                           GCancellable* _cancellable);
static void ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                               gpointer self);
static void ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void __lambda5_ (AgWidgetsPolkitDialog* self);
static void ___lambda5__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static gboolean ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                                  GdkEventKey* key);
static gboolean _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                GdkEventKey* event,
                                                                                gpointer self);
static void _ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                        gpointer self);
static void ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_real_show (GtkWidget* base);
static void ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                                const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                                 const gchar* text,
                                                                                 gpointer self);
static void ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                       gboolean authorized);
static void _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                       gboolean gained_authorization,
                                                                                       gpointer self);
static void ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                             const gchar* request,
                                             gboolean echo_on);
static void _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                           const gchar* request,
                                                                           gboolean echo_on,
                                                                           gpointer self);
static void ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                               const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                               const gchar* text,
                                                                               gpointer self);
static void ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_finalize (GObject * obj);


static inline gpointer
ag_widgets_polkit_dialog_get_instance_private (AgWidgetsPolkitDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AgWidgetsPolkitDialog_private_offset);
}


static void
_ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                          gpointer self)
{
#line 63 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
#line 176 "PolkitDialog.c"
}


static void
_ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
#line 92 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_ident_changed ((AgWidgetsPolkitDialog*) self);
#line 186 "PolkitDialog.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 133 "../src/PolkitDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 195 "PolkitDialog.c"
}


static void
__lambda5_ (AgWidgetsPolkitDialog* self)
{
#line 134 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel (self);
#line 204 "PolkitDialog.c"
}


static void
___lambda5__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 134 "../src/PolkitDialog.vala"
	__lambda5_ ((AgWidgetsPolkitDialog*) self);
#line 214 "PolkitDialog.c"
}


static void
_ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 138 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_authenticate ((AgWidgetsPolkitDialog*) self);
#line 224 "PolkitDialog.c"
}


static gboolean
_ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                       GdkEventKey* event,
                                                                       gpointer self)
{
	gboolean result;
	result = ag_widgets_polkit_dialog_on_key_release ((AgWidgetsPolkitDialog*) self, event);
#line 149 "../src/PolkitDialog.vala"
	return result;
#line 237 "PolkitDialog.c"
}


static void
_ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                   gpointer self)
{
#line 150 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
#line 247 "PolkitDialog.c"
}


AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_construct (GType object_type,
                                    const gchar* message,
                                    const gchar* icon_name,
                                    const gchar* _cookie,
                                    GList* _idents,
                                    GCancellable* _cancellable)
{
	AgWidgetsPolkitDialog * self = NULL;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
	GtkLabel* heading = NULL;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* message_label = NULL;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkEntry* _tmp12_;
	GtkEntry* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkRevealer* _tmp20_;
	GtkRevealer* _tmp21_;
	GtkLabel* _tmp22_;
	GtkComboBox* _tmp23_;
	GtkComboBox* _tmp24_;
	GtkComboBox* _tmp25_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRendererPixbuf* _tmp26_;
	GtkComboBox* _tmp27_;
	GtkCellRenderer* _tmp28_;
	GtkComboBox* _tmp29_;
	GtkCellRenderer* _tmp30_;
	GtkCellRendererText* _tmp31_;
	GtkCellRenderer* _tmp32_;
	GtkComboBox* _tmp33_;
	GtkCellRenderer* _tmp34_;
	GtkComboBox* _tmp35_;
	GtkCellRenderer* _tmp36_;
	GtkComboBox* _tmp37_;
	GtkGrid* credentials_grid = NULL;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkGrid* _tmp40_;
	GtkGrid* _tmp41_;
	GtkGrid* _tmp42_;
	GtkComboBox* _tmp43_;
	GtkGrid* _tmp44_;
	GtkEntry* _tmp45_;
	GtkGrid* _tmp46_;
	GtkRevealer* _tmp47_;
	GtkImage* image = NULL;
	GtkImage* _tmp48_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp49_;
	GtkOverlay* _tmp50_;
	GtkOverlay* _tmp51_;
	GtkImage* _tmp52_;
	gboolean _tmp53_ = FALSE;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp60_;
	GtkOverlay* _tmp61_;
	GtkLabel* _tmp62_;
	GtkLabel* _tmp63_;
	GtkGrid* _tmp64_;
	GtkButton* cancel_button = NULL;
	GtkWidget* _tmp65_;
	GtkButton* _tmp66_;
	GtkButton* authenticate_button = NULL;
	GtkWidget* _tmp67_;
	GtkButton* _tmp68_;
	GtkStyleContext* _tmp69_;
	GtkBox* _tmp70_;
	GtkWidget* action_area = NULL;
	GtkWidget* _tmp71_;
	GtkWidget* _tmp72_;
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (_cookie != NULL, NULL);
#line 50 "../src/PolkitDialog.vala"
	g_return_val_if_fail (_cancellable != NULL, NULL);
#line 52 "../src/PolkitDialog.vala"
	self = (AgWidgetsPolkitDialog*) g_object_new (object_type, "title", _ ("Authentication Dialog"), "window-position", GTK_WIN_POS_CENTER, "resizable", FALSE, "deletable", FALSE, "skip-taskbar-hint", TRUE, NULL);
#line 60 "../src/PolkitDialog.vala"
	self->priv->idents = _idents;
#line 61 "../src/PolkitDialog.vala"
	_tmp0_ = g_strdup (_cookie);
#line 61 "../src/PolkitDialog.vala"
	_g_free0 (self->priv->cookie);
#line 61 "../src/PolkitDialog.vala"
	self->priv->cookie = _tmp0_;
#line 62 "../src/PolkitDialog.vala"
	self->priv->cancellable = _cancellable;
#line 63 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->cancellable;
#line 63 "../src/PolkitDialog.vala"
	g_signal_connect_object (_tmp1_, "cancelled", (GCallback) _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled, self, 0);
#line 65 "../src/PolkitDialog.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
#line 67 "../src/PolkitDialog.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Authentication Required"));
#line 67 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp2_);
#line 67 "../src/PolkitDialog.vala"
	heading = _tmp2_;
#line 68 "../src/PolkitDialog.vala"
	_tmp3_ = heading;
#line 68 "../src/PolkitDialog.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 68 "../src/PolkitDialog.vala"
	gtk_style_context_add_class (_tmp4_, "primary");
#line 69 "../src/PolkitDialog.vala"
	_tmp5_ = heading;
#line 69 "../src/PolkitDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
#line 70 "../src/PolkitDialog.vala"
	_tmp6_ = heading;
#line 70 "../src/PolkitDialog.vala"
	gtk_label_set_xalign (_tmp6_, (gfloat) 0);
#line 72 "../src/PolkitDialog.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (message);
#line 72 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp7_);
#line 72 "../src/PolkitDialog.vala"
	message_label = _tmp7_;
#line 73 "../src/PolkitDialog.vala"
	_tmp8_ = message_label;
#line 73 "../src/PolkitDialog.vala"
	gtk_label_set_max_width_chars (_tmp8_, 60);
#line 74 "../src/PolkitDialog.vala"
	_tmp9_ = message_label;
#line 74 "../src/PolkitDialog.vala"
	g_object_set (_tmp9_, "wrap", TRUE, NULL);
#line 75 "../src/PolkitDialog.vala"
	_tmp10_ = message_label;
#line 75 "../src/PolkitDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
#line 76 "../src/PolkitDialog.vala"
	_tmp11_ = message_label;
#line 76 "../src/PolkitDialog.vala"
	gtk_label_set_xalign (_tmp11_, (gfloat) 0);
#line 78 "../src/PolkitDialog.vala"
	_tmp12_ = (GtkEntry*) gtk_entry_new ();
#line 78 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp12_);
#line 78 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 78 "../src/PolkitDialog.vala"
	self->priv->password_entry = _tmp12_;
#line 79 "../src/PolkitDialog.vala"
	_tmp13_ = self->priv->password_entry;
#line 79 "../src/PolkitDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 80 "../src/PolkitDialog.vala"
	_tmp14_ = self->priv->password_entry;
#line 80 "../src/PolkitDialog.vala"
	g_object_set (_tmp14_, "primary-icon-name", "dialog-password-symbolic", NULL);
#line 81 "../src/PolkitDialog.vala"
	_tmp15_ = self->priv->password_entry;
#line 81 "../src/PolkitDialog.vala"
	g_object_set (_tmp15_, "primary-icon-tooltip-text", _ ("Password"), NULL);
#line 83 "../src/PolkitDialog.vala"
	_tmp16_ = (GtkLabel*) gtk_label_new (NULL);
#line 83 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp16_);
#line 83 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_feedback);
#line 83 "../src/PolkitDialog.vala"
	self->priv->password_feedback = _tmp16_;
#line 84 "../src/PolkitDialog.vala"
	_tmp17_ = self->priv->password_feedback;
#line 84 "../src/PolkitDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_END);
#line 85 "../src/PolkitDialog.vala"
	_tmp18_ = self->priv->password_feedback;
#line 85 "../src/PolkitDialog.vala"
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
#line 85 "../src/PolkitDialog.vala"
	gtk_style_context_add_class (_tmp19_, GTK_STYLE_CLASS_ERROR);
#line 87 "../src/PolkitDialog.vala"
	_tmp20_ = (GtkRevealer*) gtk_revealer_new ();
#line 87 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp20_);
#line 87 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->feedback_revealer);
#line 87 "../src/PolkitDialog.vala"
	self->priv->feedback_revealer = _tmp20_;
#line 88 "../src/PolkitDialog.vala"
	_tmp21_ = self->priv->feedback_revealer;
#line 88 "../src/PolkitDialog.vala"
	_tmp22_ = self->priv->password_feedback;
#line 88 "../src/PolkitDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 90 "../src/PolkitDialog.vala"
	_tmp23_ = (GtkComboBox*) gtk_combo_box_new ();
#line 90 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp23_);
#line 90 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->idents_combo);
#line 90 "../src/PolkitDialog.vala"
	self->priv->idents_combo = _tmp23_;
#line 91 "../src/PolkitDialog.vala"
	_tmp24_ = self->priv->idents_combo;
#line 91 "../src/PolkitDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, TRUE);
#line 92 "../src/PolkitDialog.vala"
	_tmp25_ = self->priv->idents_combo;
#line 92 "../src/PolkitDialog.vala"
	g_signal_connect_object (_tmp25_, "changed", (GCallback) _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed, self, 0);
#line 94 "../src/PolkitDialog.vala"
	_tmp26_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 94 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp26_);
#line 94 "../src/PolkitDialog.vala"
	renderer = (GtkCellRenderer*) _tmp26_;
#line 95 "../src/PolkitDialog.vala"
	_tmp27_ = self->priv->idents_combo;
#line 95 "../src/PolkitDialog.vala"
	_tmp28_ = renderer;
#line 95 "../src/PolkitDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp27_, _tmp28_, FALSE);
#line 96 "../src/PolkitDialog.vala"
	_tmp29_ = self->priv->idents_combo;
#line 96 "../src/PolkitDialog.vala"
	_tmp30_ = renderer;
#line 96 "../src/PolkitDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp29_, _tmp30_, "icon-name", 0);
#line 98 "../src/PolkitDialog.vala"
	_tmp31_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 98 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp31_);
#line 98 "../src/PolkitDialog.vala"
	_g_object_unref0 (renderer);
#line 98 "../src/PolkitDialog.vala"
	renderer = (GtkCellRenderer*) _tmp31_;
#line 99 "../src/PolkitDialog.vala"
	_tmp32_ = renderer;
#line 99 "../src/PolkitDialog.vala"
	g_object_set (_tmp32_, "xpad", (guint) 6, NULL);
#line 100 "../src/PolkitDialog.vala"
	_tmp33_ = self->priv->idents_combo;
#line 100 "../src/PolkitDialog.vala"
	_tmp34_ = renderer;
#line 100 "../src/PolkitDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp33_, _tmp34_, TRUE);
#line 101 "../src/PolkitDialog.vala"
	_tmp35_ = self->priv->idents_combo;
#line 101 "../src/PolkitDialog.vala"
	_tmp36_ = renderer;
#line 101 "../src/PolkitDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp35_, _tmp36_, "text", 1);
#line 102 "../src/PolkitDialog.vala"
	_tmp37_ = self->priv->idents_combo;
#line 102 "../src/PolkitDialog.vala"
	gtk_combo_box_set_id_column (_tmp37_, 1);
#line 104 "../src/PolkitDialog.vala"
	_tmp38_ = (GtkGrid*) gtk_grid_new ();
#line 104 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp38_);
#line 104 "../src/PolkitDialog.vala"
	credentials_grid = _tmp38_;
#line 105 "../src/PolkitDialog.vala"
	_tmp39_ = credentials_grid;
#line 105 "../src/PolkitDialog.vala"
	gtk_grid_set_column_spacing (_tmp39_, 12);
#line 106 "../src/PolkitDialog.vala"
	_tmp40_ = credentials_grid;
#line 106 "../src/PolkitDialog.vala"
	gtk_grid_set_row_spacing (_tmp40_, 6);
#line 107 "../src/PolkitDialog.vala"
	_tmp41_ = credentials_grid;
#line 107 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp41_, 12);
#line 108 "../src/PolkitDialog.vala"
	_tmp42_ = credentials_grid;
#line 108 "../src/PolkitDialog.vala"
	_tmp43_ = self->priv->idents_combo;
#line 108 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 0, 0, 1, 1);
#line 109 "../src/PolkitDialog.vala"
	_tmp44_ = credentials_grid;
#line 109 "../src/PolkitDialog.vala"
	_tmp45_ = self->priv->password_entry;
#line 109 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 0, 2, 1, 1);
#line 110 "../src/PolkitDialog.vala"
	_tmp46_ = credentials_grid;
#line 110 "../src/PolkitDialog.vala"
	_tmp47_ = self->priv->feedback_revealer;
#line 110 "../src/PolkitDialog.vala"
	gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp47_, 0, 3, 1, 1);
#line 112 "../src/PolkitDialog.vala"
	_tmp48_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-password", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 112 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp48_);
#line 112 "../src/PolkitDialog.vala"
	image = _tmp48_;
#line 114 "../src/PolkitDialog.vala"
	_tmp49_ = (GtkOverlay*) gtk_overlay_new ();
#line 114 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp49_);
#line 114 "../src/PolkitDialog.vala"
	overlay = _tmp49_;
#line 115 "../src/PolkitDialog.vala"
	_tmp50_ = overlay;
#line 115 "../src/PolkitDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp50_, GTK_ALIGN_START);
#line 116 "../src/PolkitDialog.vala"
	_tmp51_ = overlay;
#line 116 "../src/PolkitDialog.vala"
	_tmp52_ = image;
#line 116 "../src/PolkitDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
#line 118 "../src/PolkitDialog.vala"
	if (g_strcmp0 (icon_name, "") != 0) {
#line 579 "PolkitDialog.c"
		GtkIconTheme* _tmp54_;
#line 118 "../src/PolkitDialog.vala"
		_tmp54_ = gtk_icon_theme_get_default ();
#line 118 "../src/PolkitDialog.vala"
		_tmp53_ = gtk_icon_theme_has_icon (_tmp54_, icon_name);
#line 585 "PolkitDialog.c"
	} else {
#line 118 "../src/PolkitDialog.vala"
		_tmp53_ = FALSE;
#line 589 "PolkitDialog.c"
	}
#line 118 "../src/PolkitDialog.vala"
	if (_tmp53_) {
#line 593 "PolkitDialog.c"
		GtkImage* overlay_image = NULL;
		GtkImage* _tmp55_;
		GtkImage* _tmp56_;
		GtkImage* _tmp57_;
		GtkOverlay* _tmp58_;
		GtkImage* _tmp59_;
#line 119 "../src/PolkitDialog.vala"
		_tmp55_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 119 "../src/PolkitDialog.vala"
		g_object_ref_sink (_tmp55_);
#line 119 "../src/PolkitDialog.vala"
		overlay_image = _tmp55_;
#line 120 "../src/PolkitDialog.vala"
		_tmp56_ = overlay_image;
#line 120 "../src/PolkitDialog.vala"
		_tmp57_ = overlay_image;
#line 120 "../src/PolkitDialog.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp57_, GTK_ALIGN_END);
#line 120 "../src/PolkitDialog.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp56_, GTK_ALIGN_END);
#line 121 "../src/PolkitDialog.vala"
		_tmp58_ = overlay;
#line 121 "../src/PolkitDialog.vala"
		_tmp59_ = overlay_image;
#line 121 "../src/PolkitDialog.vala"
		gtk_overlay_add_overlay (_tmp58_, (GtkWidget*) _tmp59_);
#line 118 "../src/PolkitDialog.vala"
		_g_object_unref0 (overlay_image);
#line 622 "PolkitDialog.c"
	}
#line 124 "../src/PolkitDialog.vala"
	_tmp60_ = (GtkGrid*) gtk_grid_new ();
#line 124 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp60_);
#line 124 "../src/PolkitDialog.vala"
	grid = _tmp60_;
#line 125 "../src/PolkitDialog.vala"
	gtk_grid_set_column_spacing (grid, 12);
#line 126 "../src/PolkitDialog.vala"
	gtk_grid_set_row_spacing (grid, 6);
#line 127 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_right ((GtkWidget*) grid, 12);
#line 127 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_left ((GtkWidget*) grid, 12);
#line 128 "../src/PolkitDialog.vala"
	_tmp61_ = overlay;
#line 128 "../src/PolkitDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp61_, 0, 0, 1, 2);
#line 129 "../src/PolkitDialog.vala"
	_tmp62_ = heading;
#line 129 "../src/PolkitDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp62_, 1, 0, 1, 1);
#line 130 "../src/PolkitDialog.vala"
	_tmp63_ = message_label;
#line 130 "../src/PolkitDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp63_, 1, 1, 1, 1);
#line 131 "../src/PolkitDialog.vala"
	_tmp64_ = credentials_grid;
#line 131 "../src/PolkitDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp64_, 1, 2, 1, 1);
#line 133 "../src/PolkitDialog.vala"
	_tmp65_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 133 "../src/PolkitDialog.vala"
	_tmp66_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, gtk_button_get_type (), GtkButton));
#line 133 "../src/PolkitDialog.vala"
	cancel_button = _tmp66_;
#line 134 "../src/PolkitDialog.vala"
	g_signal_connect_object (cancel_button, "clicked", (GCallback) ___lambda5__gtk_button_clicked, self, 0);
#line 136 "../src/PolkitDialog.vala"
	_tmp67_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Authenticate"), (gint) GTK_RESPONSE_APPLY);
#line 136 "../src/PolkitDialog.vala"
	_tmp68_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, gtk_button_get_type (), GtkButton));
#line 136 "../src/PolkitDialog.vala"
	authenticate_button = _tmp68_;
#line 137 "../src/PolkitDialog.vala"
	_tmp69_ = gtk_widget_get_style_context ((GtkWidget*) authenticate_button);
#line 137 "../src/PolkitDialog.vala"
	gtk_style_context_add_class (_tmp69_, "suggested-action");
#line 138 "../src/PolkitDialog.vala"
	g_signal_connect_object (authenticate_button, "clicked", (GCallback) _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked, self, 0);
#line 140 "../src/PolkitDialog.vala"
	gtk_window_set_default ((GtkWindow*) self, (GtkWidget*) authenticate_button);
#line 142 "../src/PolkitDialog.vala"
	_tmp70_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 142 "../src/PolkitDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp70_, (GtkWidget*) grid);
#line 144 "../src/PolkitDialog.vala"
	_tmp71_ = gtk_dialog_get_action_area ((GtkDialog*) self);
#line 144 "../src/PolkitDialog.vala"
	_tmp72_ = _g_object_ref0 (_tmp71_);
#line 144 "../src/PolkitDialog.vala"
	action_area = _tmp72_;
#line 145 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_right (action_area, 6);
#line 146 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_bottom (action_area, 6);
#line 147 "../src/PolkitDialog.vala"
	gtk_widget_set_margin_top (action_area, 14);
#line 149 "../src/PolkitDialog.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event, self, 0);
#line 150 "../src/PolkitDialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "close", (GCallback) _ag_widgets_polkit_dialog_cancel_gtk_dialog_close, self, 0);
#line 152 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_update_idents (self);
#line 153 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_select_session (self);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (action_area);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (authenticate_button);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (cancel_button);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (grid);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (overlay);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (image);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (credentials_grid);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (renderer);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (message_label);
#line 50 "../src/PolkitDialog.vala"
	_g_object_unref0 (heading);
#line 50 "../src/PolkitDialog.vala"
	return self;
#line 722 "PolkitDialog.c"
}


AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_new (const gchar* message,
                              const gchar* icon_name,
                              const gchar* _cookie,
                              GList* _idents,
                              GCancellable* _cancellable)
{
#line 50 "../src/PolkitDialog.vala"
	return ag_widgets_polkit_dialog_construct (AG_WIDGETS_TYPE_POLKIT_DIALOG, message, icon_name, _cookie, _idents, _cancellable);
#line 735 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_real_show (GtkWidget* base)
{
	AgWidgetsPolkitDialog * self;
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GtkEntry* _tmp4_;
#line 156 "../src/PolkitDialog.vala"
	self = (AgWidgetsPolkitDialog*) base;
#line 157 "../src/PolkitDialog.vala"
	GTK_WIDGET_CLASS (ag_widgets_polkit_dialog_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_dialog_get_type (), GtkDialog));
#line 159 "../src/PolkitDialog.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 159 "../src/PolkitDialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 159 "../src/PolkitDialog.vala"
	window = _tmp1_;
#line 160 "../src/PolkitDialog.vala"
	_tmp2_ = window;
#line 160 "../src/PolkitDialog.vala"
	if (_tmp2_ == NULL) {
#line 161 "../src/PolkitDialog.vala"
		_g_object_unref0 (window);
#line 161 "../src/PolkitDialog.vala"
		return;
#line 767 "PolkitDialog.c"
	}
#line 164 "../src/PolkitDialog.vala"
	_tmp3_ = window;
#line 164 "../src/PolkitDialog.vala"
	gdk_window_focus (_tmp3_, (guint32) GDK_CURRENT_TIME);
#line 165 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->password_entry;
#line 165 "../src/PolkitDialog.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
#line 156 "../src/PolkitDialog.vala"
	_g_object_unref0 (window);
#line 779 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self)
{
	GtkListStore* model = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint length = 0;
	gint active = 0;
	gchar* target_user = NULL;
	GList* _tmp1_;
	GtkComboBox* _tmp36_;
	GtkListStore* _tmp37_;
	GtkComboBox* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
#line 168 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/PolkitDialog.vala"
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, polkit_identity_get_type (), -1);
#line 169 "../src/PolkitDialog.vala"
	model = _tmp0_;
#line 172 "../src/PolkitDialog.vala"
	length = 0;
#line 173 "../src/PolkitDialog.vala"
	active = 0;
#line 175 "../src/PolkitDialog.vala"
	target_user = NULL;
#line 177 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->idents;
#line 812 "PolkitDialog.c"
	{
		GList* ident_collection = NULL;
		GList* ident_it = NULL;
#line 177 "../src/PolkitDialog.vala"
		ident_collection = _tmp1_;
#line 177 "../src/PolkitDialog.vala"
		for (ident_it = ident_collection; ident_it != NULL; ident_it = ident_it->next) {
#line 820 "PolkitDialog.c"
			PolkitIdentity* ident = NULL;
#line 177 "../src/PolkitDialog.vala"
			ident = (PolkitIdentity*) ident_it->data;
#line 824 "PolkitDialog.c"
			{
				PolkitIdentity* _tmp2_;
				gchar* name = NULL;
				PolkitIdentity* _tmp3_;
				gchar* _tmp4_;
				PolkitIdentity* _tmp5_;
				GtkListStore* _tmp26_;
				GtkTreeIter _tmp27_ = {0};
				GtkListStore* _tmp28_;
				GtkTreeIter _tmp29_;
				const gchar* _tmp30_;
				PolkitIdentity* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gint _tmp35_;
#line 178 "../src/PolkitDialog.vala"
				_tmp2_ = ident;
#line 178 "../src/PolkitDialog.vala"
				if (_tmp2_ == NULL) {
#line 179 "../src/PolkitDialog.vala"
					continue;
#line 846 "PolkitDialog.c"
				}
#line 182 "../src/PolkitDialog.vala"
				_tmp3_ = ident;
#line 182 "../src/PolkitDialog.vala"
				_tmp4_ = polkit_identity_to_string (_tmp3_);
#line 182 "../src/PolkitDialog.vala"
				name = _tmp4_;
#line 184 "../src/PolkitDialog.vala"
				_tmp5_ = ident;
#line 184 "../src/PolkitDialog.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, polkit_unix_user_get_type ())) {
#line 858 "PolkitDialog.c"
					struct passwd* pwd = NULL;
					PolkitIdentity* _tmp6_;
					struct passwd* _tmp7_;
					struct passwd* _tmp8_;
#line 185 "../src/PolkitDialog.vala"
					_tmp6_ = ident;
#line 185 "../src/PolkitDialog.vala"
					_tmp7_ = getpwuid ((uid_t) polkit_unix_user_get_uid (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, polkit_unix_user_get_type (), PolkitUnixUser)));
#line 185 "../src/PolkitDialog.vala"
					pwd = _tmp7_;
#line 186 "../src/PolkitDialog.vala"
					_tmp8_ = pwd;
#line 186 "../src/PolkitDialog.vala"
					if (_tmp8_ != NULL) {
#line 873 "PolkitDialog.c"
						gchar* pw_name = NULL;
						struct passwd* _tmp9_;
						const gchar* _tmp10_;
						gchar* _tmp11_;
						gboolean _tmp12_ = FALSE;
						const gchar* _tmp13_;
						const gchar* _tmp17_;
						gchar* _tmp18_;
#line 187 "../src/PolkitDialog.vala"
						_tmp9_ = pwd;
#line 187 "../src/PolkitDialog.vala"
						_tmp10_ = _tmp9_->pw_name;
#line 187 "../src/PolkitDialog.vala"
						_tmp11_ = g_strdup (_tmp10_);
#line 187 "../src/PolkitDialog.vala"
						pw_name = _tmp11_;
#line 188 "../src/PolkitDialog.vala"
						_tmp13_ = target_user;
#line 188 "../src/PolkitDialog.vala"
						if (_tmp13_ == NULL) {
#line 894 "PolkitDialog.c"
							gint _tmp14_;
#line 188 "../src/PolkitDialog.vala"
							_tmp14_ = length;
#line 188 "../src/PolkitDialog.vala"
							_tmp12_ = _tmp14_ < 2;
#line 900 "PolkitDialog.c"
						} else {
#line 188 "../src/PolkitDialog.vala"
							_tmp12_ = FALSE;
#line 904 "PolkitDialog.c"
						}
#line 188 "../src/PolkitDialog.vala"
						if (_tmp12_) {
#line 908 "PolkitDialog.c"
							const gchar* _tmp15_;
							gchar* _tmp16_;
#line 189 "../src/PolkitDialog.vala"
							_tmp15_ = pw_name;
#line 189 "../src/PolkitDialog.vala"
							_tmp16_ = g_strdup (_tmp15_);
#line 189 "../src/PolkitDialog.vala"
							_g_free0 (target_user);
#line 189 "../src/PolkitDialog.vala"
							target_user = _tmp16_;
#line 919 "PolkitDialog.c"
						}
#line 192 "../src/PolkitDialog.vala"
						_tmp17_ = pw_name;
#line 192 "../src/PolkitDialog.vala"
						_tmp18_ = g_strdup (_tmp17_);
#line 192 "../src/PolkitDialog.vala"
						_g_free0 (name);
#line 192 "../src/PolkitDialog.vala"
						name = _tmp18_;
#line 186 "../src/PolkitDialog.vala"
						_g_free0 (pw_name);
#line 931 "PolkitDialog.c"
					}
				} else {
					PolkitIdentity* _tmp19_;
#line 194 "../src/PolkitDialog.vala"
					_tmp19_ = ident;
#line 194 "../src/PolkitDialog.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, polkit_unix_group_get_type ())) {
#line 939 "PolkitDialog.c"
						struct group* gwd = NULL;
						PolkitIdentity* _tmp20_;
						struct group* _tmp21_;
						struct group* _tmp22_;
#line 195 "../src/PolkitDialog.vala"
						_tmp20_ = ident;
#line 195 "../src/PolkitDialog.vala"
						_tmp21_ = getgrgid ((gid_t) polkit_unix_group_get_gid (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, polkit_unix_group_get_type (), PolkitUnixGroup)));
#line 195 "../src/PolkitDialog.vala"
						gwd = _tmp21_;
#line 196 "../src/PolkitDialog.vala"
						_tmp22_ = gwd;
#line 196 "../src/PolkitDialog.vala"
						if (_tmp22_ != NULL) {
#line 954 "PolkitDialog.c"
							struct group* _tmp23_;
							const gchar* _tmp24_;
							gchar* _tmp25_;
#line 197 "../src/PolkitDialog.vala"
							_tmp23_ = gwd;
#line 197 "../src/PolkitDialog.vala"
							_tmp24_ = _tmp23_->gr_name;
#line 197 "../src/PolkitDialog.vala"
							_tmp25_ = g_strdup_printf (_ ("Group: %s"), _tmp24_);
#line 197 "../src/PolkitDialog.vala"
							_g_free0 (name);
#line 197 "../src/PolkitDialog.vala"
							name = _tmp25_;
#line 968 "PolkitDialog.c"
						}
					}
				}
#line 201 "../src/PolkitDialog.vala"
				_tmp26_ = model;
#line 201 "../src/PolkitDialog.vala"
				gtk_list_store_append (_tmp26_, &_tmp27_);
#line 201 "../src/PolkitDialog.vala"
				iter = _tmp27_;
#line 202 "../src/PolkitDialog.vala"
				_tmp28_ = model;
#line 202 "../src/PolkitDialog.vala"
				_tmp29_ = iter;
#line 202 "../src/PolkitDialog.vala"
				_tmp30_ = name;
#line 202 "../src/PolkitDialog.vala"
				_tmp31_ = ident;
#line 202 "../src/PolkitDialog.vala"
				gtk_list_store_set (_tmp28_, &_tmp29_, 0, "avatar-default-symbolic", 1, _tmp30_, 2, _tmp31_, -1);
#line 204 "../src/PolkitDialog.vala"
				_tmp32_ = name;
#line 204 "../src/PolkitDialog.vala"
				_tmp33_ = g_get_user_name ();
#line 204 "../src/PolkitDialog.vala"
				if (g_strcmp0 (_tmp32_, _tmp33_) == 0) {
#line 994 "PolkitDialog.c"
					gint _tmp34_;
#line 205 "../src/PolkitDialog.vala"
					_tmp34_ = length;
#line 205 "../src/PolkitDialog.vala"
					active = _tmp34_;
#line 1000 "PolkitDialog.c"
				}
#line 208 "../src/PolkitDialog.vala"
				_tmp35_ = length;
#line 208 "../src/PolkitDialog.vala"
				length = _tmp35_ + 1;
#line 177 "../src/PolkitDialog.vala"
				_g_free0 (name);
#line 1008 "PolkitDialog.c"
			}
		}
	}
#line 211 "../src/PolkitDialog.vala"
	_tmp36_ = self->priv->idents_combo;
#line 211 "../src/PolkitDialog.vala"
	_tmp37_ = model;
#line 211 "../src/PolkitDialog.vala"
	gtk_combo_box_set_model (_tmp36_, (GtkTreeModel*) _tmp37_);
#line 212 "../src/PolkitDialog.vala"
	_tmp38_ = self->priv->idents_combo;
#line 212 "../src/PolkitDialog.vala"
	_tmp39_ = active;
#line 212 "../src/PolkitDialog.vala"
	gtk_combo_box_set_active (_tmp38_, _tmp39_);
#line 214 "../src/PolkitDialog.vala"
	_tmp40_ = length;
#line 214 "../src/PolkitDialog.vala"
	if (_tmp40_ < 2) {
#line 1028 "PolkitDialog.c"
		const gchar* _tmp41_;
		const gchar* _tmp42_;
#line 215 "../src/PolkitDialog.vala"
		_tmp41_ = target_user;
#line 215 "../src/PolkitDialog.vala"
		_tmp42_ = g_get_user_name ();
#line 215 "../src/PolkitDialog.vala"
		if (g_strcmp0 (_tmp41_, _tmp42_) == 0) {
#line 1037 "PolkitDialog.c"
			GtkComboBox* _tmp43_;
			GtkComboBox* _tmp44_;
#line 216 "../src/PolkitDialog.vala"
			_tmp43_ = self->priv->idents_combo;
#line 216 "../src/PolkitDialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp43_, FALSE);
#line 217 "../src/PolkitDialog.vala"
			_tmp44_ = self->priv->idents_combo;
#line 217 "../src/PolkitDialog.vala"
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp44_, TRUE);
#line 1048 "PolkitDialog.c"
		} else {
			GtkComboBox* _tmp45_;
#line 219 "../src/PolkitDialog.vala"
			_tmp45_ = self->priv->idents_combo;
#line 219 "../src/PolkitDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp45_, FALSE);
#line 1055 "PolkitDialog.c"
		}
	}
#line 168 "../src/PolkitDialog.vala"
	_g_free0 (target_user);
#line 168 "../src/PolkitDialog.vala"
	_g_object_unref0 (model);
#line 1062 "PolkitDialog.c"
}


static void
_ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                            const gchar* text,
                                                                            gpointer self)
{
#line 230 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_show_error ((AgWidgetsPolkitDialog*) self, text);
#line 1073 "PolkitDialog.c"
}


static void
_ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                  gboolean gained_authorization,
                                                                                  gpointer self)
{
#line 231 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_session_completed ((AgWidgetsPolkitDialog*) self, gained_authorization);
#line 1084 "PolkitDialog.c"
}


static void
_ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                      const gchar* request,
                                                                      gboolean echo_on,
                                                                      gpointer self)
{
#line 232 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_request ((AgWidgetsPolkitDialog*) self, request, echo_on);
#line 1096 "PolkitDialog.c"
}


static void
_ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                          const gchar* text,
                                                                          gpointer self)
{
#line 233 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_on_pk_show_info ((AgWidgetsPolkitDialog*) self, text);
#line 1107 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	PolkitIdentity* _tmp1_;
	const gchar* _tmp2_;
	PolkitAgentSession* _tmp3_;
	PolkitAgentSession* _tmp4_;
	gulong _tmp5_;
	PolkitAgentSession* _tmp6_;
	gulong _tmp7_;
	PolkitAgentSession* _tmp8_;
	gulong _tmp9_;
	PolkitAgentSession* _tmp10_;
	gulong _tmp11_;
	PolkitAgentSession* _tmp12_;
#line 224 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 225 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 226 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 1135 "PolkitDialog.c"
	}
#line 229 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->pk_identity;
#line 229 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->cookie;
#line 229 "../src/PolkitDialog.vala"
	_tmp3_ = polkit_agent_session_new (_tmp1_, _tmp2_);
#line 229 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_session);
#line 229 "../src/PolkitDialog.vala"
	self->priv->pk_session = _tmp3_;
#line 230 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->pk_session;
#line 230 "../src/PolkitDialog.vala"
	_tmp5_ = g_signal_connect_object (_tmp4_, "show-error", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error, self, 0);
#line 230 "../src/PolkitDialog.vala"
	self->priv->error_signal_id = _tmp5_;
#line 231 "../src/PolkitDialog.vala"
	_tmp6_ = self->priv->pk_session;
#line 231 "../src/PolkitDialog.vala"
	_tmp7_ = g_signal_connect_object (_tmp6_, "completed", (GCallback) _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed, self, 0);
#line 231 "../src/PolkitDialog.vala"
	self->priv->complete_signal_id = _tmp7_;
#line 232 "../src/PolkitDialog.vala"
	_tmp8_ = self->priv->pk_session;
#line 232 "../src/PolkitDialog.vala"
	_tmp9_ = g_signal_connect_object (_tmp8_, "request", (GCallback) _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request, self, 0);
#line 232 "../src/PolkitDialog.vala"
	self->priv->request_signal_id = _tmp9_;
#line 233 "../src/PolkitDialog.vala"
	_tmp10_ = self->priv->pk_session;
#line 233 "../src/PolkitDialog.vala"
	_tmp11_ = g_signal_connect_object (_tmp10_, "show-info", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info, self, 0);
#line 233 "../src/PolkitDialog.vala"
	self->priv->info_signal_id = _tmp11_;
#line 234 "../src/PolkitDialog.vala"
	_tmp12_ = self->priv->pk_session;
#line 234 "../src/PolkitDialog.vala"
	polkit_agent_session_initiate (_tmp12_);
#line 1175 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
#line 237 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 238 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 1189 "PolkitDialog.c"
		PolkitAgentSession* _tmp1_;
		gulong _tmp2_;
		PolkitAgentSession* _tmp3_;
		gulong _tmp4_;
		PolkitAgentSession* _tmp5_;
		gulong _tmp6_;
		PolkitAgentSession* _tmp7_;
		gulong _tmp8_;
#line 239 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->pk_session;
#line 239 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->error_signal_id;
#line 239 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp1_, _tmp2_);
#line 240 "../src/PolkitDialog.vala"
		_tmp3_ = self->priv->pk_session;
#line 240 "../src/PolkitDialog.vala"
		_tmp4_ = self->priv->complete_signal_id;
#line 240 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp3_, _tmp4_);
#line 241 "../src/PolkitDialog.vala"
		_tmp5_ = self->priv->pk_session;
#line 241 "../src/PolkitDialog.vala"
		_tmp6_ = self->priv->request_signal_id;
#line 241 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp5_, _tmp6_);
#line 242 "../src/PolkitDialog.vala"
		_tmp7_ = self->priv->pk_session;
#line 242 "../src/PolkitDialog.vala"
		_tmp8_ = self->priv->info_signal_id;
#line 242 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp7_, _tmp8_);
#line 243 "../src/PolkitDialog.vala"
		_g_object_unref0 (self->priv->pk_session);
#line 243 "../src/PolkitDialog.vala"
		self->priv->pk_session = NULL;
#line 1226 "PolkitDialog.c"
	}
}


static void
ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	GtkEntry* _tmp1_;
	GtkRevealer* _tmp2_;
	PolkitAgentSession* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
#line 247 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 248 "../src/PolkitDialog.vala"
	if (_tmp0_ == NULL) {
#line 249 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_select_session (self);
#line 1248 "PolkitDialog.c"
	}
#line 252 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->password_entry;
#line 252 "../src/PolkitDialog.vala"
	g_object_set (_tmp1_, "secondary-icon-name", "", NULL);
#line 253 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->feedback_revealer;
#line 253 "../src/PolkitDialog.vala"
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 255 "../src/PolkitDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
#line 256 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->pk_session;
#line 256 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->password_entry;
#line 256 "../src/PolkitDialog.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 256 "../src/PolkitDialog.vala"
	polkit_agent_session_response (_tmp3_, _tmp5_);
#line 1268 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
#line 259 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/PolkitDialog.vala"
	self->priv->canceling = TRUE;
#line 261 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 261 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 1284 "PolkitDialog.c"
		PolkitAgentSession* _tmp1_;
#line 262 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->pk_session;
#line 262 "../src/PolkitDialog.vala"
		polkit_agent_session_cancel (_tmp1_);
#line 1290 "PolkitDialog.c"
	}
#line 265 "../src/PolkitDialog.vala"
	g_debug ("PolkitDialog.vala:265: Authentication cancelled");
#line 266 "../src/PolkitDialog.vala"
	self->was_canceled = TRUE;
#line 268 "../src/PolkitDialog.vala"
	self->priv->canceling = FALSE;
#line 269 "../src/PolkitDialog.vala"
	g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
#line 1300 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
#line 272 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->idents_combo;
#line 275 "../src/PolkitDialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 275 "../src/PolkitDialog.vala"
	iter = _tmp1_;
#line 275 "../src/PolkitDialog.vala"
	if (!_tmp2_) {
#line 276 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 277 "../src/PolkitDialog.vala"
		return;
#line 1332 "PolkitDialog.c"
	}
#line 280 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->idents_combo;
#line 280 "../src/PolkitDialog.vala"
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 280 "../src/PolkitDialog.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 280 "../src/PolkitDialog.vala"
	model = _tmp5_;
#line 281 "../src/PolkitDialog.vala"
	_tmp6_ = model;
#line 281 "../src/PolkitDialog.vala"
	if (_tmp6_ == NULL) {
#line 282 "../src/PolkitDialog.vala"
		_g_object_unref0 (model);
#line 282 "../src/PolkitDialog.vala"
		return;
#line 1350 "PolkitDialog.c"
	}
#line 285 "../src/PolkitDialog.vala"
	_tmp7_ = model;
#line 285 "../src/PolkitDialog.vala"
	_tmp8_ = iter;
#line 285 "../src/PolkitDialog.vala"
	gtk_tree_model_get (_tmp7_, &_tmp8_, 2, &self->priv->pk_identity, -1, -1);
#line 286 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_select_session (self);
#line 272 "../src/PolkitDialog.vala"
	_g_object_unref0 (model);
#line 1362 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                  gboolean authorized)
{
	gboolean _tmp0_ = FALSE;
#line 289 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/PolkitDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
#line 291 "../src/PolkitDialog.vala"
	if (!authorized) {
#line 291 "../src/PolkitDialog.vala"
		_tmp0_ = TRUE;
#line 1379 "PolkitDialog.c"
	} else {
		GCancellable* _tmp1_;
#line 291 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->cancellable;
#line 291 "../src/PolkitDialog.vala"
		_tmp0_ = g_cancellable_is_cancelled (_tmp1_);
#line 1386 "PolkitDialog.c"
	}
#line 291 "../src/PolkitDialog.vala"
	if (_tmp0_) {
#line 1390 "PolkitDialog.c"
		gboolean _tmp2_;
		GtkEntry* _tmp3_;
		GtkEntry* _tmp4_;
#line 292 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->canceling;
#line 292 "../src/PolkitDialog.vala"
		if (!_tmp2_) {
#line 293 "../src/PolkitDialog.vala"
			ag_widgets_polkit_dialog_on_pk_show_error (self, _ ("Authentication failed. Please try again."));
#line 1400 "PolkitDialog.c"
		}
#line 296 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_deselect_session (self);
#line 297 "../src/PolkitDialog.vala"
		_tmp3_ = self->priv->password_entry;
#line 297 "../src/PolkitDialog.vala"
		gtk_entry_set_text (_tmp3_, "");
#line 298 "../src/PolkitDialog.vala"
		_tmp4_ = self->priv->password_entry;
#line 298 "../src/PolkitDialog.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
#line 299 "../src/PolkitDialog.vala"
		ag_widgets_polkit_dialog_select_session (self);
#line 300 "../src/PolkitDialog.vala"
		return;
#line 1416 "PolkitDialog.c"
	} else {
#line 302 "../src/PolkitDialog.vala"
		g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
#line 1420 "PolkitDialog.c"
	}
}


static void
ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                        const gchar* request,
                                        gboolean echo_on)
{
	GtkEntry* _tmp0_;
#line 306 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/PolkitDialog.vala"
	g_return_if_fail (request != NULL);
#line 307 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 307 "../src/PolkitDialog.vala"
	gtk_entry_set_visibility (_tmp0_, echo_on);
#line 308 "../src/PolkitDialog.vala"
	if (!g_str_has_prefix (request, "Password:")) {
#line 1441 "PolkitDialog.c"
		GtkLabel* _tmp1_;
#line 309 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->password_label;
#line 309 "../src/PolkitDialog.vala"
		gtk_label_set_label (_tmp1_, request);
#line 1447 "PolkitDialog.c"
	}
}


static void
ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                           const gchar* text)
{
	GtkEntry* _tmp0_;
	GtkLabel* _tmp1_;
	GtkRevealer* _tmp2_;
#line 313 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/PolkitDialog.vala"
	g_return_if_fail (text != NULL);
#line 314 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 314 "../src/PolkitDialog.vala"
	g_object_set (_tmp0_, "secondary-icon-name", "dialog-error-symbolic", NULL);
#line 315 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->password_feedback;
#line 315 "../src/PolkitDialog.vala"
	gtk_label_set_label (_tmp1_, text);
#line 316 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->feedback_revealer;
#line 316 "../src/PolkitDialog.vala"
	gtk_revealer_set_reveal_child (_tmp2_, TRUE);
#line 317 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_shake (self);
#line 1477 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp9_;
	gint _tmp10_;
#line 321 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/PolkitDialog.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
#line 323 "../src/PolkitDialog.vala"
	x = _tmp0_;
#line 323 "../src/PolkitDialog.vala"
	y = _tmp1_;
#line 1498 "PolkitDialog.c"
	{
		gint n = 0;
#line 325 "../src/PolkitDialog.vala"
		n = 0;
#line 1503 "PolkitDialog.c"
		{
			gboolean _tmp2_ = FALSE;
#line 325 "../src/PolkitDialog.vala"
			_tmp2_ = TRUE;
#line 325 "../src/PolkitDialog.vala"
			while (TRUE) {
#line 1510 "PolkitDialog.c"
				gint _tmp4_;
				gint diff = 0;
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 325 "../src/PolkitDialog.vala"
				if (!_tmp2_) {
#line 1519 "PolkitDialog.c"
					gint _tmp3_;
#line 325 "../src/PolkitDialog.vala"
					_tmp3_ = n;
#line 325 "../src/PolkitDialog.vala"
					n = _tmp3_ + 1;
#line 1525 "PolkitDialog.c"
				}
#line 325 "../src/PolkitDialog.vala"
				_tmp2_ = FALSE;
#line 325 "../src/PolkitDialog.vala"
				_tmp4_ = n;
#line 325 "../src/PolkitDialog.vala"
				if (!(_tmp4_ < 10)) {
#line 325 "../src/PolkitDialog.vala"
					break;
#line 1535 "PolkitDialog.c"
				}
#line 326 "../src/PolkitDialog.vala"
				diff = 15;
#line 327 "../src/PolkitDialog.vala"
				_tmp5_ = n;
#line 327 "../src/PolkitDialog.vala"
				if ((_tmp5_ % 2) == 0) {
#line 328 "../src/PolkitDialog.vala"
					diff = -15;
#line 1545 "PolkitDialog.c"
				}
#line 331 "../src/PolkitDialog.vala"
				_tmp6_ = x;
#line 331 "../src/PolkitDialog.vala"
				_tmp7_ = diff;
#line 331 "../src/PolkitDialog.vala"
				_tmp8_ = y;
#line 331 "../src/PolkitDialog.vala"
				gtk_window_move ((GtkWindow*) self, _tmp6_ + _tmp7_, _tmp8_);
#line 333 "../src/PolkitDialog.vala"
				while (TRUE) {
#line 333 "../src/PolkitDialog.vala"
					if (!gtk_events_pending ()) {
#line 333 "../src/PolkitDialog.vala"
						break;
#line 1561 "PolkitDialog.c"
					}
#line 334 "../src/PolkitDialog.vala"
					gtk_main_iteration ();
#line 1565 "PolkitDialog.c"
				}
#line 337 "../src/PolkitDialog.vala"
				g_usleep ((gulong) 10000);
#line 1569 "PolkitDialog.c"
			}
		}
	}
#line 340 "../src/PolkitDialog.vala"
	_tmp9_ = x;
#line 340 "../src/PolkitDialog.vala"
	_tmp10_ = y;
#line 340 "../src/PolkitDialog.vala"
	gtk_window_move ((GtkWindow*) self, _tmp9_, _tmp10_);
#line 1579 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                          const gchar* text)
{
#line 343 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 343 "../src/PolkitDialog.vala"
	g_return_if_fail (text != NULL);
#line 344 "../src/PolkitDialog.vala"
	g_info ("PolkitDialog.vala:344: %s", text);
#line 1593 "PolkitDialog.c"
}


static gboolean
ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                         GdkEventKey* key)
{
	gboolean result = FALSE;
	guint _tmp0_;
#line 347 "../src/PolkitDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 347 "../src/PolkitDialog.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 348 "../src/PolkitDialog.vala"
	_tmp0_ = key->keyval;
#line 348 "../src/PolkitDialog.vala"
	switch (_tmp0_) {
#line 348 "../src/PolkitDialog.vala"
		case GDK_KEY_KP_Enter:
#line 348 "../src/PolkitDialog.vala"
		case GDK_KEY_Return:
#line 1615 "PolkitDialog.c"
		{
#line 351 "../src/PolkitDialog.vala"
			ag_widgets_polkit_dialog_authenticate (self);
#line 352 "../src/PolkitDialog.vala"
			result = GDK_EVENT_STOP;
#line 352 "../src/PolkitDialog.vala"
			return result;
#line 1623 "PolkitDialog.c"
		}
		default:
#line 348 "../src/PolkitDialog.vala"
		break;
#line 1628 "PolkitDialog.c"
	}
#line 355 "../src/PolkitDialog.vala"
	result = GDK_EVENT_PROPAGATE;
#line 355 "../src/PolkitDialog.vala"
	return result;
#line 1634 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_class_init (AgWidgetsPolkitDialogClass * klass)
{
#line 27 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/PolkitDialog.vala"
	g_type_class_adjust_private_offset (klass, &AgWidgetsPolkitDialog_private_offset);
#line 27 "../src/PolkitDialog.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget *)) ag_widgets_polkit_dialog_real_show;
#line 27 "../src/PolkitDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = ag_widgets_polkit_dialog_finalize;
#line 27 "../src/PolkitDialog.vala"
	ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL] = g_signal_new ("done", AG_WIDGETS_TYPE_POLKIT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1651 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_instance_init (AgWidgetsPolkitDialog * self)
{
#line 27 "../src/PolkitDialog.vala"
	self->priv = ag_widgets_polkit_dialog_get_instance_private (self);
#line 29 "../src/PolkitDialog.vala"
	self->was_canceled = FALSE;
#line 31 "../src/PolkitDialog.vala"
	self->priv->pk_session = NULL;
#line 32 "../src/PolkitDialog.vala"
	self->priv->pk_identity = NULL;
#line 42 "../src/PolkitDialog.vala"
	self->priv->canceling = FALSE;
#line 1668 "PolkitDialog.c"
}


static void
ag_widgets_polkit_dialog_finalize (GObject * obj)
{
	AgWidgetsPolkitDialog * self;
#line 27 "../src/PolkitDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog);
#line 31 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_session);
#line 32 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_identity);
#line 41 "../src/PolkitDialog.vala"
	_g_free0 (self->priv->cookie);
#line 44 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->feedback_revealer);
#line 45 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_label);
#line 46 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_feedback);
#line 47 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 48 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->idents_combo);
#line 27 "../src/PolkitDialog.vala"
	G_OBJECT_CLASS (ag_widgets_polkit_dialog_parent_class)->finalize (obj);
#line 1696 "PolkitDialog.c"
}


GType
ag_widgets_polkit_dialog_get_type (void)
{
	static volatile gsize ag_widgets_polkit_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&ag_widgets_polkit_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AgWidgetsPolkitDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ag_widgets_polkit_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AgWidgetsPolkitDialog), 0, (GInstanceInitFunc) ag_widgets_polkit_dialog_instance_init, NULL };
		GType ag_widgets_polkit_dialog_type_id;
		ag_widgets_polkit_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "AgWidgetsPolkitDialog", &g_define_type_info, 0);
		AgWidgetsPolkitDialog_private_offset = g_type_add_instance_private (ag_widgets_polkit_dialog_type_id, sizeof (AgWidgetsPolkitDialogPrivate));
		g_once_init_leave (&ag_widgets_polkit_dialog_type_id__volatile, ag_widgets_polkit_dialog_type_id);
	}
	return ag_widgets_polkit_dialog_type_id__volatile;
}



